program mul_expr;
const maxlength = 100; digits = ['0'..'9'];
      INCORRECT = 'incorrect expression';
type mapped_mnog = array[1..2, 1..maxlength] of integer;
var fin, fout : text;
    K, test : integer;
    expression : string;

{procedure parses string expression and create appropriate array,
where for each column procedure stores power and koefficient bounded to x}
procedure map_to_array(mnog:string; var map:mapped_mnog; var len:integer);
var x_pos, koef, power, val_code, i:integer;
begin
    if mnog[1] = 'x' then
        mnog := '+' + mnog;
    len := 0;
    {find all numbers bounded to x and delete them from input string}
    while length(mnog) > 0 do
    begin
        koef := 0;
        power := 0;
        x_pos := pos('x', mnog);
        if x_pos > 0 then
        begin
            val_code := 0;
            if mnog[x_pos-1] in digits then
               val(copy(mnog, 1, x_pos-1), koef, val_code)
            else {if no written koefficient before x^}
               if mnog[x_pos-1]='+' then koef := 1
               else if mnog[x_pos-1]='-' then koef := -1
               else val_code := -1;
            if val_code <> 0 then
            begin
                len := -1;
                exit;
            end;
            {get power of x}
            if mnog[x_pos+1] <> '^' then
            begin
                power := 1;
                delete(mnog, 1, x_pos);
            end else
            begin
                delete(mnog, 1, x_pos+1);
                i := 1;
                while (i < length(mnog)) and (mnog[i] in digits) do
                    i := i + 1;
                if i < length(mnog) then i := i - 1;
                val(copy(mnog, 1, i), power, val_code);
                if val_code <> 0 then
                begin
                    len := -1;
                    exit;
                end;
                delete(mnog, 1, i);
            end; {end if mnog[x_pos+1] <> '^'}
        end {end if x_pos > 0}
        else if length(mnog) > 0 then
        begin
            {last free number or koef before x^0}
            val(mnog, koef, val_code);
            if val_code <> 0 then
            begin
                len := -1;
                exit;
            end;
            mnog := ''; {delete last koefficient and sure that length(mnog)=0}
        end;
        len := len + 1;
        map[1, len] := power;
        map[2, len] := koef;
    end; {end while length(mnog) > 0}
end;

{sort mapped array by power to transform polynom into canonical view}
procedure sort_by_power(var mnog:mapped_mnog; len:integer);
var i, j, power, koef: integer;
begin
    for j := 1 to len do
    for i := 1 to len - 1 do
    if mnog[1, i] < mnog[1, i + 1] then
    begin
        power := mnog[1, i];
        mnog[1, i] := mnog[1, i + 1];
        mnog[1, i + 1] := power;
        koef := mnog[2, i];
        mnog[2, i] := mnog[2, i + 1];
        mnog[2, i + 1] := koef;
    end;
end;

{map array with power and digits to appropriate polynomial expression}
function map_to_string(mnog:mapped_mnog; len:integer):string;
var i : integer; result, power, koef : string;
begin
    result := '';
    for i := 1 to len do
    begin
        str(mnog[1, i], power);
        str(mnog[2, i], koef);
        if mnog[2, i] > 1 then
            result := result + '+' + koef
        else if (mnog[2, i] = 1) and (mnog[1, i] = 0) then
            result := result + '+' + koef
        else if mnog[2, i] = 1 then
            result := result + '+';

        if mnog[2, i] < -1 then
            result := result + koef
        else if (mnog[2, i] = -1) and (mnog[1, i] = 0) then
            result := result + koef
        else if mnog[2, i] = -1 then
            result := result + '-';

        if (mnog[1, i] > 1) and (mnog[2, i] <> 0) then
            result := result + 'x^' + power
        else if (mnog[1, i] = 1) and (mnog[2, i] <> 0) then
            result := result + 'x';
    end;
    if result[1] = '+' then
        delete(result, 1, 1);
    map_to_string := result;
end;

{simulate multiply expressions via mapped arrays}
function multiply(mnog1, mnog2:string):string;
var map1, map2, result : mapped_mnog;
    len1, len2, len_res, i, j, k, power, koef : integer;
    power_found : boolean;
begin
    map_to_array(mnog1, map1, len1);
    map_to_array(mnog2, map2, len2);
    if (len1 < 0) or (len2 < 0) then
    begin
        multiply := INCORRECT;
        exit;
    end;
    len_res := 0;
    for i := 1 to len1 do
    for j := 1 to len2 do
    begin
        power := map1[1,i] + map2[1,j];
        koef := map1[2,i] * map2[2,j];
        power_found := False;
        for k := 1 to len_res do
        if result[1, k] = power then
        begin
            result[2, k] := result[2, k] + koef;
            power_found := True;
            break;
        end;
        if not power_found then
        begin
            len_res := len_res + 1;
            result[1, len_res] := power;
            result[2, len_res] := koef;
        end;
    end;
    sort_by_power(result, len_res);
    multiply := map_to_string(result, len_res);
end;

{check for general errors, split expression into two polynoms and multiply it}
function simplify(expression:string):string;
var mul_pos : integer;
    mnog1, mnog2 : string;
begin
    mul_pos := pos('*', expression);
    if mul_pos = 0 then
    begin
        simplify := INCORRECT;
        exit;
    end;
    mnog1 := copy(expression, 1, mul_pos-1);
    mnog2 := copy(expression, mul_pos+1, length(expression));
    if (mnog1[1] <> '(') or (mnog1[length(mnog1)] <> ')')
    or (mnog2[1] <> '(') or (mnog2[length(mnog2)] <> ')') then
    begin
        simplify := INCORRECT;
        exit;
    end;
    {delete parentheses}
    delete(mnog1,1,1);
    delete(mnog1,length(mnog1),1);
    delete(mnog2,1,1);
    delete(mnog2,length(mnog2),1);

    simplify := multiply(mnog1, mnog2);
end;

{main begin}
begin
    assign(fin,'task2.dat');
    reset(fin);
    assign(fout,'task2.res');
    rewrite(fout);
    readln(fin,K);
    for test := 1 to K do
    begin
       readln(fin, expression);
       expression := simplify(expression);
       writeln(fout, expression);
       writeln(fout);
    end;
    close(fin);
    close(fout);
end.

